# This makefile simplifies perl module builds.
#

#PERL_VERSION :=	5.8.8
#PERL_VER :=	5.8
#PERL_VER :=	5.8.8

# Build environment
#PERL_CMD := $(STAGING_DIR)/opt/bin/perl
#PERL_LIB := $(STAGING_DIR)/opt/lib/perl5/$(PERL_VER)

# Module install prefix
#PERL_SITELIB := /opt/lib/perl5/$(PERL_VER)
PERL_MYLIB := /opt/lib/perl5/$(PERL_VERSION)

define perlmod/Configure
	(cd $(PKG_BUILD_DIR); \
	$(2) \
	$(PERL_CMD) Makefile.PL \
		$(1) \
		PERL5LIB=$(STAGING_DIR)/opt/lib/perl5/site_perl \
		PREFIX=$(PERL_PREFIX) \
		DESTDIR=$(PKG_INSTALL_DIR) \
	);
#	(cd $(PKG_BUILD_DIR); \
#	PERL5LIB=$(PERL_LIB) \
#	$(2) \
#	$(PERL_CMD) Makefile.PL \
#		$(1) \
#		PERL_LIB=$(PERL_LIB) \
#		PERL_ARCHLIB=$(PERL_LIB) \
#		INSTALLSITELIB=$(PERL_SITELIB) \
#		INSTALLSITEARCH=$(PERL_SITELIB) \
#		DESTDIR=$(PKG_INSTALL_DIR) \
#	);
endef

define perlmod/Compile
	$(2) \
	$(MAKE) -C $(PKG_BUILD_DIR) \
		$(1) \
		$(PERL_INC) \
		PERL5LIB=$(STAGING_DIR)/opt/lib/perl5/site_perl \
		DESTDIR=$(PKG_INSTALL_DIR) \
		install
#	PERL5LIB=$(PERL_LIB) \
#	$(2) \
#	$(MAKE) -C $(PKG_BUILD_DIR) \
#		$(1) \
#		install
endef

define perlmod/Install
	$(INSTALL_DIR) $(strip $(1))$(PERL_MYLIB)
	(cd $(PKG_INSTALL_DIR)$(PERL_MYLIB) && \
		rsync --relative -rlHp \
		--exclude=\*.pod \
		--exclude=.packlist \
		$(addprefix --exclude=/,$(strip $(3))) \
		$(strip $(2)) $(strip $(1))$(PERL_MYLIB))
#--itemize-changes --prune-empty-dirs not supported at FC1

	chmod -R u+w $(strip $(1))$(PERL_MYLIB)

	@echo "---> Stripping modules in: $(strip $(1))$(PERL_MYLIB)"
#	find $(strip $(1))$(PERL_MYLIB) -name \*.pm -or -name \*.pl | \
#	xargs -r sed -i \
#		-e '/^=\(head\|pod\|item\|over\|back\)/,/^=cut/d' \
#		-e '/^=\(head\|pod\|item\|over\|back\)/,$$$$d' \
#		-e '/^#$$$$/d' \
#		-e '/^#[^!"'"'"']/d'

#	try those old scripts instead... environment too big for xargs
#	sh ./files/deletepod.sh $(PKG_INSTALL_DIR)
	sh ./files/strippm.sh $(strip $(1))$(PERL_MYLIB)

endef

define oldperlmod/Install
	$(INSTALL_DIR) $(strip $(1))$(PERL_SITELIB)
	(cd $(PKG_INSTALL_DIR)$(PERL_SITELIB) && \
		rsync --relative -rlHp \
		--exclude=\*.pod \
		--exclude=.packlist \
		$(addprefix --exclude=/,$(strip $(3))) \
		$(strip $(2)) $(strip $(1))$(PERL_SITELIB))
#--itemize-changes --prune-empty-dirs not supported at FC1

	chmod -R u+w $(strip $(1))$(PERL_SITELIB)

	@echo "---> Stripping modules in: $(strip $(1))$(PERL_SITELIB)"
#	find $(strip $(1))$(PERL_SITELIB) -name \*.pm -or -name \*.pl | \
#	xargs -r sed -i \
#		-e '/^=\(head\|pod\|item\|over\|back\)/,/^=cut/d' \
#		-e '/^=\(head\|pod\|item\|over\|back\)/,$$$$d' \
#		-e '/^#$$$$/d' \
#		-e '/^#[^!"'"'"']/d'

#	try those old scripts instead... environment too big for xargs
#	sh ./files/deletepod.sh $(PKG_INSTALL_DIR)
	sh ./files/strippm.sh $(strip $(1))$(PERL_SITELIB)

endef
